function diffPogonOZ
close all, clear all %vodenje robota po trajektoriji
global R L Ts

IZRISUJ=1; % omogoimo sprotni izris

Ts=0.033; % cas vzorenja
t=0:Ts:10; % referenna trajektorija
R=0.04; % radij kolesa
L=0.08; % razdalja med kolesi

q=[0 -0.5 0];	% zacetno stanje dejanskega vozila

q_odo=q;  % predpostavimo, da poznamo zaetno lego robota za odometrijo

Q=[];Qr=[];Qo=[];E=[];Etrans=[];U=[];Tvzorcenja=[]; EE=[];
tt=0;


%inicializacija grafike
global hhh 
if (IZRISUJ) InitGrafic; end

q_ref=[1 1 1];    % trenutno nima ni uporabljena




for i=1:length(t)
     
    
    %%%%%%%%%%% krmiljenje, doloitev vhodov 
    v = 0.5;
    w = 1;
      
    
    %%%%%%%%%%%% odometrija
    % na podlagi znanih vhodnih komand ocenjujemo lego z Eulerjevo
    % integracijo
   
    q_odo=q*.1;   %TO JE LE DEMO, tu dodajte odometrijo
    
    
    
  
    
    
    
    %%%%%%%%%%% dejansko gibanje robota
    [q]=SimulacijaDejanskegaRobora(q,v,w);
    
    
    
    
    
    
    %%%%%%%%%%% hranimo rezultate
    Q=[Q;q]; Qo=[Qo;q_odo]; Qr=[Qr;q_ref]; U=[U;[v, w]];  
    Tvzorcenja=[Tvzorcenja; tt];
    tt=tt+Ts;
 
    
    
   if (IZRISUJ)
        DrawRobot(q',1);     % drugi parameter: robot=1, odometrija=2
        DrawRobot(q_odo',2); % drugi parameter: robot=1, odometrija=2
        set(hhh(3),'XData',Q(:,1),'YData',Q(:,2));  % izris poti
        set(hhh(4),'XData',Qo(:,1),'YData',Qo(:,2));  % izris odometrije
        set(hhh(5),'XData',Qr(:,1),'YData',Qr(:,2));  % izris referenne poti

        pause(0.03);
        drawnow;        
   end
   
end

figure
plot(Q(:,1),Q(:,2),Qo(:,1),Qo(:,2),'--')
xlabel('t [s]'),ylabel('x [m], y [m]')
figure
plot(Tvzorcenja,U(:,1),Tvzorcenja,U(:,2),'--')
xlabel('t [s]'),ylabel('v [m/s], \omega [rad/s]'),legend('v','\omega'),







%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%% FUNKCIJE    %%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function a = PopraviCiklicnostKota(a)
    a=atan2(sin(a),cos(a));   % prevedemo kot na obmoje [-pi,pi]
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [q]=SimulacijaDejanskegaRobora(q,v,w)
  global R L Ts
  flag_sum = 1; % stikalo za vkolop ali izkolp uma
  flag_pri = 1; % stikalo za vkolop ali izkolp pristranskosti
  
  %nimamo tonega podatka o dimenzijah robota R in L, ki so v resnici
  Rt=R+0.003*flag_pri;
  Lt=L-0.004*flag_pri;
  % dodatno se dejansko kolo zaradi majnih zdrsov, neravnin, itd... vrti z
  % nekim dodanim umom
  SIGMA_W=0.3;
  % kotne hitrosti koles glede na vhode z dodanim umom
  wR=1/(R)*(v+w*(L)/2)+SIGMA_W*randn(1,1)*flag_sum;
  wL=1/(R)*(v-w*(L)/2)+SIGMA_W*randn(1,1)*flag_sum;
  
  % dejanska hitrost robota je torej
    vt=Rt/2*(wR+wL);
    wt=Rt/Lt*(wR-wL);
   
 	q(1)=q(1) + Ts*vt*cos( q(3) + Ts*wt/2 );
	q(2)=q(2) + Ts*vt*sin( q(3) + Ts*wt/2 );
    q(3)=q(3) + Ts*wt;
    
    q(3)=PopraviCiklicnostKota(q(3));    % popravi kot q(3)    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function DrawRobot(Xr,tip);
global hhh

P=[1 4 4 -4 -4 -1 -1 -4 -4 4 4 1 1;...  % oblika robota
   3 3 4 4 3 3 -3 -3 -4 -4 -3 -3 3]*.01;         

theta = Xr(3); 
R=[cos(theta) -sin(theta); sin(theta) cos(theta)];
T=repmat([Xr(1);Xr(2)],1,size(P,2)) ;

% toke obrisa robota transliramo in rotiramo
P=R*P+T; 
set(hhh(tip),'XData',P(1,:),'YData',P(2,:))   % izris dejanskega robota
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function InitGrafic()
global hhh
figure(10) ;clf ; 
hold on;
zoom on;
title('Robot z differencialnim pogonom');xlabel('x (m)');ylabel('y (m)');
axis([-10,10,-10,10]*.15); 
axis equal

hhh(1)=plot(0,0,'b','erasemode','xor') ;     % dejanski robot 
hhh(2)=plot(0,0,'g','erasemode','xor') ;     % robot z odometrijo 

hhh(3)=plot(0,0,'--b','erasemode','none') ;  % dejanska pot
hhh(4)=plot(0,0,'--g','erasemode','none') ;  % pot dobljena z odometrijo
hhh(5)=plot(0,0,':r','erasemode','none') ;   % referenna pot 

legend('rob','robOdo','pot','odometrija','referenca')
hold off;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%




