function diffPogonOZ
close all, clear all %vodenje robota po trajektoriji
global R L D Ts

IZRISUJ=1; % omogoimo izris


Ts=0.033; % cas vzorenja
t=0:Ts:10; % referenna trajektorija

R=0.02; % radij kolesa
L=0.08; % razdalja med kolesi
D=0.07; % razdalja med osmi zadnjih in prednjih koles



q=[0 -0.5 0];			% zacetno stanje

q_odo=q;  % predpostavimo, da poznamo zaetno lego robota

Q=[];Qr=[];Qo=[];E=[];Etrans=[];U=[];Tvzorcenja=[]; EE=[];

tt=0;



%inicializacija grafike
global hhh 
if (IZRISUJ) InitGrafic; end








for i=1:length(t)
     
    
    %%%%%%%%%%% krmiljenje, doloitev vhodov 
    v = 0.4;
    alfa=pi/10+ pi/10*sin(tt*2*pi*.4);
    
    
    
    %%%%%%%%%%%% odometrija
    % na podlagi znanih vhodnih komand ocenjujemo lego z Eulerjevo
    % integracijo
   
 	q_odo=q*.1; % kar nekaj...
    
    
    
    
    % dejansko gibanje robota (z Euler integracijo)
    [q]=SimulacijaDejanskegaRobora(q,v,alfa);
    
    
    
    
    
    
    % hranimo rezultate
    Q=[Q;q]; Qo=[Qo;q_odo]; U=[U;[v, alfa]];  
    Tvzorcenja=[Tvzorcenja; tt];
    tt=tt+Ts;
 
    
    
   if (IZRISUJ)
        %alpha=asin(tt/10);
       DrawRobot(q',alfa,1);     % drugi parameter: robot=1, odometrija=2
        
%         DrawRobot(q_odo', alfa, 2); % drugi parameter: robot=1, odometrija=2
        
         set(hhh(3),'XData',Q(:,1),'YData',Q(:,2));  % izris poti
%         set(hhh(4),'XData',Qo(:,1),'YData',Qo(:,2));  % izris odometrije

        pause(0.03);
        drawnow;        
   end
   
end

figure
plot(Q(:,1),Q(:,2),Qo(:,1),Qo(:,2),'--')
xlabel('t [s]'),ylabel('x [m], y [m]')
figure
plot(Tvzorcenja,U(:,1),Tvzorcenja,U(:,2),'--')
xlabel('t [s]'),ylabel('v [m/s], \omega [rad/s]'),legend('v','\omega'),



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function a = PopraviCiklicnostKota(a)
    a=atan2(sin(a),cos(a));   % prevedemo kot na obmoje [-pi,pi]
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [q]=SimulacijaDejanskegaRobora(q,v,alfa)
  global R L D Ts
  %nimamo tonega podatka o dimenzijah robota R in L, ki so v resnici
  Rt=R+0.001*0;
  Lt=L-0.002*0;
  Dt=D+0.001*0;
  % dodatno se dejansko kolo zaradi majnih zdrsov, neravnin, itd... vrti z
  % nekim dodanim umom
  SIGMA_W=0.4*0;
  % kotne hitrosti koles glede na vhode z dodanim umom
  w=v/Dt*tan(alfa);  
    
  wR=1/(R)*(v+w*(L)/2)+SIGMA_W*randn(1,1);
  wL=1/(R)*(v-w*(L)/2)+SIGMA_W*randn(1,1);
  
  % dejanska hitrost hitrost robota je torej
    vt=Rt/2*(wR+wL);
    wt=Rt/Lt*(wR-wL);

    q(1)=q(1) + Ts*vt*cos( q(3) + Ts*wt/2 );
	q(2)=q(2) + Ts*vt*sin( q(3) + Ts*wt/2 );
    q(3)=q(3) + Ts*wt;
    
    q(3)=PopraviCiklicnostKota(q(3));    % popravi kot q(3)    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%










%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function DrawRobot(Xr,alpha,tip);
global hhh

 Pzad=[7  1  1 4 4 -4 -4 -1 -1 -4 -4 4 4 1 1    7    ;...  % oblika zadnjega dela
      0  1  3 3 4 4 3 3 -3 -3 -4 -4 -3 -3 -1    0  ]*.01;
  
Pkol=[3    11  11  3 3 ;...  % oblika sprednjega kolesa
      -.5  -.5  .5 .5 -.5 ]*.01;


theta = Xr(3); 

R=[cos(theta) -sin(theta); sin(theta) cos(theta)];
T=repmat([Xr(1);Xr(2)],1,size(Pzad,2)) ;

R2=[cos(theta+alpha) -sin(theta+alpha); sin(theta+alpha) cos(theta+alpha)];
T2=repmat([0.07;0],1,size(Pkol,2)) ;

T3=repmat([Xr(1);Xr(2)],1,size(Pkol,2)) ;


% toke obrisa robota transliramo in rotiramo
Pzad=R*Pzad+T; 
Pkol=R2*(Pkol-T2)+T3 + R*T2; 

set(hhh(tip),'XData',Pzad(1,:),'YData',Pzad(2,:))   % izris dejanskega robota

set(hhh(tip+4),'XData',Pkol(1,:),'YData',Pkol(2,:))   % izris kolesa dejanskega robota


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%
%=============================================================================
% LocalRoboInit
% Local function to initialize the robobrc animation.  If the animation
% window already exists, it is brought to the front.  Otherwise, a new
% figure window is created.
%=============================================================================
%
function InitGrafic()
global hhh
figure(10) ;clf ; 
hold on;

zoom on;
title('Robot z differencialnim pogonom');xlabel('x (m)');ylabel('y (m)');

axis([-10,10,-10,10]*.1); 
axis equal

%plot(znacke(1,:),znacke(2,:),'b*')
hhh(1)=plot(0,0,'b','erasemode','xor') ;     % dejanski robot 
hhh(2)=plot(0,0,'g','erasemode','xor') ;     % robot z odometrijo 

hhh(3)=plot(0,0,'--b','erasemode','none') ;  % dejanska pot
hhh(4)=plot(0,0,'--g','erasemode','none') ;  % pot dobljena z odometrijo

hhh(5)=plot(0,0,'b','erasemode','xor') ;     % dejanski robot kolo 
hhh(6)=plot(0,0,'g','erasemode','xor') ;     % robot z odometrijo kolo



legend('rob','robOdo','pot','odometrija')

hold off;




